Index: HelenOS.config
===================================================================
--- HelenOS.config	(revision 68c2e322fe139c566807fa33bbdd12c28034efa7)
+++ HelenOS.config	(revision f92976f9995a9c61772c6381e0c90c7b84561fff)
@@ -66,4 +66,5 @@
 @ "integratorcp" Integratorcp
 @ "beagleboardxm" BeogleBoard-xM
+@ "beaglebone" BeogleBone
 ! [PLATFORM=arm32] MACHINE (choice)
 
@@ -97,6 +98,5 @@
 % CPU type
 @ "armv7_a" ARMv7-A
-! [PLATFORM=arm32&MACHINE=beagleboardxm] PROCESSOR (choice)
-
+! [PLATFORM=arm32&(MACHINE=beagleboardxm|MACHINE=beaglebone)] PROCESSOR (choice)
 
 % RAM disk format
Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision 68c2e322fe139c566807fa33bbdd12c28034efa7)
+++ boot/arch/arm32/Makefile.inc	(revision f92976f9995a9c61772c6381e0c90c7b84561fff)
@@ -35,5 +35,5 @@
 endif
 
-ifeq ($(MACHINE), beagleboardxm)
+ifeq ($(MACHINE), $(filter $(MACHINE),beagleboardxm beaglebone))
 	BOOT_OUTPUT = image.boot
 	POST_OUTPUT = $(ROOT_PATH)/uImage.bin
Index: defaults/arm32/beaglebone/Makefile.config
===================================================================
--- defaults/arm32/beaglebone/Makefile.config	(revision f92976f9995a9c61772c6381e0c90c7b84561fff)
+++ defaults/arm32/beaglebone/Makefile.config	(revision f92976f9995a9c61772c6381e0c90c7b84561fff)
@@ -0,0 +1,8 @@
+# Machine type
+MACHINE = beaglebone
+
+# RAM disk format
+RDFMT = fat
+
+#framebuffer
+CONFIG_FB = n
Index: kernel/arch/arm32/Makefile.inc
===================================================================
--- kernel/arch/arm32/Makefile.inc	(revision 68c2e322fe139c566807fa33bbdd12c28034efa7)
+++ kernel/arch/arm32/Makefile.inc	(revision f92976f9995a9c61772c6381e0c90c7b84561fff)
@@ -78,4 +78,8 @@
 endif
 
+ifeq ($(MACHINE),beaglebone)
+        ARCH_SOURCES += arch/$(KARCH)/src/mach/beaglebone/beaglebone.c
+endif
+
 ifeq ($(CONFIG_PL050),y)
 	ARCH_SOURCES += genarch/src/drivers/pl050/pl050.c
Index: kernel/arch/arm32/include/mach/beaglebone/beaglebone.h
===================================================================
--- kernel/arch/arm32/include/mach/beaglebone/beaglebone.h	(revision f92976f9995a9c61772c6381e0c90c7b84561fff)
+++ kernel/arch/arm32/include/mach/beaglebone/beaglebone.h	(revision f92976f9995a9c61772c6381e0c90c7b84561fff)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2012 Matteo Facchinetti
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup arm32beaglebone beaglebone
+ *  @brief BeagleBone platform.
+ *  @ingroup arm32
+ * @{
+ */
+/** @file
+ *  @brief BeagleBone platform driver.
+ */
+
+#ifndef KERN_arm32_beaglebone_H_
+#define KERN_arm32_beaglebone_H_
+
+#include <arch/machine_func.h>
+
+extern struct arm_machine_ops bbone_machine_ops;
+
+#endif
+
+/** @}
+ */
+
Index: kernel/arch/arm32/src/mach/beaglebone/beaglebone.c
===================================================================
--- kernel/arch/arm32/src/mach/beaglebone/beaglebone.c	(revision f92976f9995a9c61772c6381e0c90c7b84561fff)
+++ kernel/arch/arm32/src/mach/beaglebone/beaglebone.c	(revision f92976f9995a9c61772c6381e0c90c7b84561fff)
@@ -0,0 +1,115 @@
+/*
+ * Copyright (c) 2012 Matteo Facchinetti
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup arm32beaglebone
+ * @{
+ */
+/** @file
+ *  @brief BeagleBone platform driver.
+ */
+
+#include <arch/exception.h>
+#include <arch/mach/beaglebone/beaglebone.h>
+#include <interrupt.h>
+#include <ddi/ddi.h>
+#include <ddi/device.h>
+
+static void bbone_init(void);
+static void bbone_timer_irq_start(void);
+static void bbone_cpu_halt(void);
+static void bbone_get_memory_extents(uintptr_t *start, size_t *size);
+static void bbone_irq_exception(unsigned int exc_no, istate_t *istate);
+static void bbone_frame_init(void);
+static void bbone_output_init(void);
+static void bbone_input_init(void);
+static size_t bbone_get_irq_count(void);
+static const char *bbone_get_platform_name(void);
+
+struct arm_machine_ops bbone_machine_ops = {
+	bbone_init,
+	bbone_timer_irq_start,
+	bbone_cpu_halt,
+	bbone_get_memory_extents,
+	bbone_irq_exception,
+	bbone_frame_init,
+	bbone_output_init,
+	bbone_input_init,
+	bbone_get_irq_count,
+	bbone_get_platform_name
+};
+
+static void bbone_init(void)
+{
+}
+
+static void bbone_timer_irq_start(void)
+{
+}
+
+static void bbone_cpu_halt(void)
+{
+}
+
+/** Get extents of available memory.
+ *
+ * @param start		Place to store memory start address (physical).
+ * @param size		Place to store memory size.
+ */
+static void bbone_get_memory_extents(uintptr_t *start, size_t *size)
+{
+}
+
+static void bbone_irq_exception(unsigned int exc_no, istate_t *istate)
+{
+}
+
+static void bbone_frame_init(void)
+{
+}
+
+static void bbone_output_init(void)
+{
+}
+
+static void bbone_input_init(void)
+{
+}
+
+size_t bbone_get_irq_count(void)
+{
+	return 0;
+}
+
+const char *bbone_get_platform_name(void)
+{
+	return "beaglebone";
+}
+
+/**
+ * @}
+ */
+
Index: kernel/arch/arm32/src/machine_func.c
===================================================================
--- kernel/arch/arm32/src/machine_func.c	(revision 68c2e322fe139c566807fa33bbdd12c28034efa7)
+++ kernel/arch/arm32/src/machine_func.c	(revision f92976f9995a9c61772c6381e0c90c7b84561fff)
@@ -42,5 +42,5 @@
 #include <arch/mach/integratorcp/integratorcp.h>
 #include <arch/mach/testarm/testarm.h>
-#include <arch/mach/beagleboardxm/beagleboardxm.h>
+#include <arch/mach/beaglebone/beaglebone.h>
 
 /** Pointer to machine_ops structure being used. */
@@ -58,4 +58,6 @@
 #elif defined(MACHINE_beagleboardxm)
 	machine_ops = &bbxm_machine_ops;
+#elif defined(MACHINE_beaglebone)
+	machine_ops = &bbone_machine_ops;
 #else
 #error Machine type not defined.
